v=B.xy;
w=C.xy;
v=round(v*100)/100;
w=round(w*100)/100;

wn=w/|w|;

wp=perp(wn);

v1=(v*wn)*wn;
v2=(v*wp)*wp;

sk=v*wn;

snap(x):=(
   xx=round(x);
   if(|xx-x|<0.2,xx,x);
);

//draw(v1);
//draw(v2);

v=snap(sk)*wn+v2;



B.xy=v;

err(perp(b,-15*wn));
err(perp(b,wn));

apply(-15..15,i,draw(perp(b,i*wn),alpha->0.3));


fillpoly(((4.5,0.5),(12.5,0.5),(12.5,4.5),(4.5,4.5)),color->(1,1,1));
drawall(cycle(((4.5,0.5),(12.5,0.5),(12.5,4.5),(4.5,4.5))),color->(0,0,0));


drawtext(B+(0.2,0.2),"$v="+v+"$",size->14);
drawtext(C+(0.2,0.2),"$w="+w+"$",size->14);

drawtext((5,4),"Kanonisches Skalarprodukt:",size->18);
drawtext((5,3),"$\langle v,w\rangle=\;\;v_x\cdot w_x\; +\; v_y\cdot w_y$"
,size->16);

form(t):=if(t<0,"("+t+")",t);


drawtext((5,2),"$\langle v,w\rangle=\;\;"+form(v.x)+"\cdot "+form(w.x)+"\; +\; "+form(v.y)+"\cdot "+form(w.y)+"$"
,size->16);


drawtext((5,1),"$\langle v,w\rangle=\;\;"+(v*w)+"$"
,size->16);





